Тёмный

L30. Print all the Nodes at a distance of K in Binary Tree | C++ | Java 

take U forward
Подписаться 593 тыс.
Просмотров 173 тыс.
50% 1

Entire DSA Course: takeuforward.org/strivers-a2z...
Check our Website:
Linkedin/Instagram/Telegram: linktr.ee/takeUforward
#treeSeries #striver #placements

Опубликовано:

 

25 июн 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 244   
@takeUforward
@takeUforward 2 года назад
Please likeeee, shareeee and subscribeeeeeeee :) Also follow me at Insta: Striver_79
@willturner3440
@willturner3440 2 года назад
Done brother this thing is obvious 😁
@ayushjain386
@ayushjain386 2 года назад
On 50 line ,i think wha pe parent_track[current]. second aana chaiye because we marked the parents like 5->3 5 ka parent 3 hai
@PrinceKumar-el7ob
@PrinceKumar-el7ob 2 года назад
@@ayushjain386 no it's correct 5->3 mtlb 5 ka parent 3 hai to parent_track[current] =3 hi aayega if current=5
@JoshMartin47
@JoshMartin47 2 года назад
unordered_map in c++ does take O(1) time for look up. so the time complexity in worst case will come out to O(n)
@soumyadeepdas1536
@soumyadeepdas1536 Год назад
Bhaiya for the mark parent function there is probably no need to carry the target node seperately ig?? coz we are just marking the parent nodes for the correspnding child nodes??
@symbol767
@symbol767 2 года назад
To perhaps make it more clear for those still a bit confused He basically turned a Binary Tree into an Undirected Graph, this method is incredible and extremely useful.
@vivekmishra641
@vivekmishra641 8 месяцев назад
100 bat ki 1 bat
@nopecharon
@nopecharon Год назад
What i learned: When you have to traverse back use a map to store the parent node
@phatcat7924
@phatcat7924 Год назад
these are the comments i look for they straight away go into my revision notes.
@prakhargupta5410
@prakhargupta5410 Год назад
@@phatcat7924 could you please share your notes with us🥺
@tushar8579
@tushar8579 Год назад
@@phatcat7924 Bro he is basically making a graph and doing bfs to reach all nodes at kth level.
@pulkitjain5159
@pulkitjain5159 11 месяцев назад
yups
@uRamPlus
@uRamPlus 2 года назад
Self Notes: 🍋 Mark each node to its parent to traverse upwards 🍋 We will do a BFS traversal starting from the target node 🍋 As long as we have not seen our node previously, Traverse up, left, right until reached Kth distance 🍋 when reached Kth distance, break out of BFS loop and remaining node's values in our queue is our result
@gautamarora6556
@gautamarora6556 2 года назад
Thank you
@thinkingmad1685
@thinkingmad1685 2 года назад
Your self notes help me as well 😄
@shikharbansal2942
@shikharbansal2942 2 года назад
Helpfull Thanks!
@parthsalat
@parthsalat Год назад
Wherever I go...I search for your "self notes"
@ashishdhal4614
@ashishdhal4614 Год назад
Teach me your ways senpai
@supratimbhattacharjee5324
@supratimbhattacharjee5324 2 года назад
So basically we are traversing a tree as a graph and doing BFS from the given node
@PrinceKumar-el7ob
@PrinceKumar-el7ob 2 года назад
yeah forming a graph and doing BFS exactly.
@aman5534
@aman5534 Год назад
Its kinda funny 😂
@rushidesai2836
@rushidesai2836 Год назад
Tree is a graph.
@anujjain9273
@anujjain9273 2 года назад
with this logic , i code code k distance node downwards and upwards, really impressed with the logic , dry run took time , i did it two times though , Thanks for making such content
@himanshugupta7010
@himanshugupta7010 2 года назад
We can implement it using recursion as well. As on every node , there will be 3 recursion .. i.e for left , for right and for parent .. code is given below :: void makeParent(TreeNode* root,unordered_map &parent){ queue q; q.push(root); while(!q.empty()){ int n= q.size(); for(int i=0;ileft) { parent[node->left]=node; q.push(node->left); } if(node->right){ parent[node->right]=node; q.push(node->right); } } } } class Solution { public: vector distanceK(TreeNode* root, TreeNode* target, int k) { unordered_map parent; makeParent(root,parent); unordered_map visited; vector ans; solve(target,parent,visited,k,ans); return ans; } void solve(TreeNode* target,unordered_map &parent,unordered_map &visited,int k,vector &ans){ if(k==0){ ans.push_back(target->val); } visited[target]=true; if(target->left && !visited[target->left]){ solve(target->left,parent,visited,k-1,ans); } if(target->right && !visited[target->right]){ solve(target->right,parent,visited,k-1,ans); } if(parent[target]!=NULL && !visited[parent[target]]){ solve(parent[target],parent,visited,k-1,ans); } }
@adolft_official
@adolft_official Год назад
also you can store the parents usng dfs recursively
@shashankojha3452
@shashankojha3452 2 года назад
Thanks!
@pulkitjain5159
@pulkitjain5159 11 месяцев назад
crux : converted tree into an undirected graph and applied a dfs / bfs .
@shubhamuppal-1599
@shubhamuppal-1599 5 месяцев назад
after doing every question of this series i get to know that main motive is not to prepare for questions in interview/coding round but to identify pattern. Must say striver your content is top notch.
@armaanhadiq3741
@armaanhadiq3741 Год назад
Basically, here we are making the undirected graph from given tree and using BFS(level order traversal of graph) to find different vertices at distance k
@pulkitjain5159
@pulkitjain5159 11 месяцев назад
yes
@beamncrash9971
@beamncrash9971 11 месяцев назад
yeah more like creating a adjaceny list and then doing BFS from target node
@pratyushnarain5220
@pratyushnarain5220 2 года назад
you can also do it in O(H) space by stroring root to target node path and then calling the k-down function on them.
@nikhilmeena8585
@nikhilmeena8585 Год назад
even we can do it without storing the root to that node path , by just checking whether if a nodes leftchild contains target , then we will search for possible answers in the right subtree of current node , and if found in rightNode then w will check possible answers in left subtree , if the node is itself target than we can just see all its childrens at distance k.
@_sf_editz1870
@_sf_editz1870 6 месяцев назад
here is the java code with target as integer and also target as a node thank you striver bhayya for making the concept clearer public class Solution { public static List distanceK(TreeNode root, int target, int k) { Map parent = new HashMap(); markParents(root, null, parent); Queue queue = new LinkedList(); Set visited = new HashSet(); TreeNode tgt = findNode(target , root); queue.offer(tgt); visited.add(tgt); int level = 0; while (!queue.isEmpty()) { if (level == k) break; int size = queue.size(); level++; for (int i = 0; i < size; i++) { TreeNode current = queue.poll(); if (current.left != null && !visited.contains(current.left)) { queue.offer(current.left); visited.add(current.left); } if (current.right != null && !visited.contains(current.right)) { queue.offer(current.right); visited.add(current.right); } TreeNode parentNode = parent.get(current); if (parentNode != null && !visited.contains(parentNode)) { queue.offer(parentNode); visited.add(parentNode); } } } List result = new ArrayList(); while (!queue.isEmpty()) { result.add(queue.poll().val); } Collections.sort(result); return result; } public static void markParents(TreeNode root, TreeNode par, Map parent) { if (root == null) return; parent.put(root, par); markParents(root.left, root, parent); markParents(root.right, root, parent); } static TreeNode findNode(int val , TreeNode root){ if(root==null) return null; if(root.val == val) return root; TreeNode left = findNode(val , root.left); TreeNode right = findNode(val , root.right); if(left==null) return right; if(right == null) return left; return null; } }
@solankiketul5640
@solankiketul5640 Месяц назад
I have one more solution with time complexity O(2n) and space complexity O(n). 1.) Take a map which stores the pair (Node value, direction from root, left or right), eg, (4, left) 2.) in the process, store the level of the target and the direction, level=1, direction= left 3.) if the target is on left, take all the values from level+k with direction left. In our eg, from map[3], we will get 7 and 4 4.) now for ancestor, take map[k-level], so we will have map[1] and as the target value is on left, we will take the nodes with direction right from map[1]. In our example it is 1.
@ishangujarathi10
@ishangujarathi10 8 месяцев назад
Superb Intuition and explanation, this problem falls in the range of Hard Problem, but your technique and approach makes it super easy to understand and also code!!
@gandhijainamgunvantkumar6783
@gandhijainamgunvantkumar6783 2 года назад
What an amazing explanation. I was able to do the whole code by myself just after you did a dry run and told the logic. Thank you so much bhaiya for making trees easy for us. :)
@cinime
@cinime Год назад
Understood! Such a fantastic explanation as always, thank you very much!!
@stith_pragya
@stith_pragya 23 дня назад
Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@gouravkumar7459
@gouravkumar7459 2 года назад
The easiest explanation for this problem so far on youtube.
@charlesbabbage6786
@charlesbabbage6786 2 месяца назад
What a mind blowing solution!!
@vaibhavgupta973
@vaibhavgupta973 2 года назад
starting mae toh ache samaj nhi aa rha tha . but jaise hi code walk through kra ... sab samaj aa gaya ache se. Thanks!!
@BinduMahapatra-sq6vh
@BinduMahapatra-sq6vh 2 дня назад
Ek TVF and dusra TUF bas ye dono hee rocking hai abhi tou.
@harshmittal3128
@harshmittal3128 Год назад
Thanks for such a great explanation striver... This was a very good question , learnt multiple new approaches from this one ..
@Anonymous-uj3jx
@Anonymous-uj3jx Год назад
Why everything becomes soo easy when striver teaches it ? Mann you are magical 💖
@AppaniMadhavi
@AppaniMadhavi 3 месяца назад
ya
@vanshajtiwari1282
@vanshajtiwari1282 23 дня назад
Love you bhai love you, You are amazing, amazing explaination.
@paritoshdadhich2954
@paritoshdadhich2954 9 месяцев назад
Thank you for the best possible solution. Hats off to your efforts
@willturner3440
@willturner3440 2 года назад
For me this is the most awaited video.. Love you striver 😍
@NeerajSharma-mz4es
@NeerajSharma-mz4es 2 года назад
I leanned a new approach thanks to u sir
@abhineetkapil
@abhineetkapil 8 месяцев назад
Nice and easy explaination. !
@user-es4vn2uw5l
@user-es4vn2uw5l Месяц назад
You are magic striver and you create magic
@emmatime2016
@emmatime2016 2 года назад
Soooooo clear !!!! Thank you!
@teja1384
@teja1384 Год назад
if we have to traverse a tree upward then we have to make parent map which store the parent of every node , Nice explanation.
@silicon9794
@silicon9794 Год назад
Good explanation bro. Understood properly. Thankyou :)
@rajatrajgautam3224
@rajatrajgautam3224 27 дней назад
I basically learned if we want to go backward in a tree we need to use a map to store the parent node.........Incredible !
@bhashkarbelwal4116
@bhashkarbelwal4116 3 месяца назад
you are amazing tutor #takeuForward bro
@deepakjain4481
@deepakjain4481 7 месяцев назад
i think for this method we should have used 3 pointers in a binary tree left right and parent while constructing tree and then simply traverse the tree and finding the target of the tree and then using a map i which two variable are there int for distance and node for distinct element
@sikandarchaudharyzx9014
@sikandarchaudharyzx9014 Год назад
Sometimes you make the easy questions very complex.
@ishachauhan6477
@ishachauhan6477 19 часов назад
very well explained thankyou sir
@palakmantry
@palakmantry 2 года назад
Thank you for the explanation, really helpful
@ayushidalal5488
@ayushidalal5488 Год назад
Amazing explanation! Thankyou so much :)
@tusharnain6652
@tusharnain6652 2 года назад
There is no need of passing target to makr parent function.
@gubbalamalleswari5892
@gubbalamalleswari5892 8 месяцев назад
Super explanation
@samyakjain7422
@samyakjain7422 2 года назад
just love ur videos man...great explanation...:)
@tanishq2766
@tanishq2766 7 месяцев назад
I solved it differently(return all the downward nodes at a distance k from some particular node and some simple manipulations), but i think this approach is easier to come up with if someone have studied standard graph problems
@rishabhkumar8115
@rishabhkumar8115 2 года назад
Very well explained bhaiya! understood🔥
@riteshkhadse4517
@riteshkhadse4517 2 года назад
to mark visited nodes we can use set instead of map.
@amisha2545
@amisha2545 2 года назад
🔥couldn’t have been better!
@mansisethi8127
@mansisethi8127 19 дней назад
Dope question
@aakriti1
@aakriti1 2 года назад
Understood, Great explanation! 🤩
@iWontFakeIt
@iWontFakeIt Год назад
here, the problem in leetcode has constraints given that 0
@051-avnee4
@051-avnee4 Год назад
Awesome explanation 💫💫!!! Understood .....
@nagavedareddy5891
@nagavedareddy5891 2 года назад
Perfect and most efficient explanation.. But small optimisation would be using hash set instead of Hashmap for visited.
@theghost9362
@theghost9362 11 месяцев назад
ommmg , thanks , I was doing something completely different , I was trying to compute a list that represent that BT , and then compute the the parent and children K times until i get the result , but you're algo is a lot faster
@user-tk2vg5jt3l
@user-tk2vg5jt3l 3 месяца назад
Thank you Bhaiya
@aryashjain7893
@aryashjain7893 Год назад
Ill do this again , accha problem hai revision lagega thenks striver
@Abhishek-do8mp
@Abhishek-do8mp 2 года назад
just one word - amazing
@Yag116
@Yag116 Год назад
Solution :where we are given value of target Node void markparent(Node* root , unordered_map &keep_parent,int t,Node* &tn ){ if(!root) return; queue q; q.push(root); while(!q.empty()){ int n = q.size(); for(int i=0;idata==t) tn=root; //only for getting target node form given key if(root->left){ keep_parent[root->left]=root; // root k left ka parent root mark kr diya q.push(root->left); } if(root->right){ keep_parent[root->right]=root; // root k right ka parent root mark kr diya q.push(root->right); } } } } vector KDistanceNodes(Node* root , int target , int k){ unordered_map Keep_parent ; Node* targetN =NULL; markparent(root,Keep_parent,target,targetN); // sare parent aa gye unordered_map visted; queue q; q.push(targetN); visted[targetN] = true; int curr_dist=0; while(!q.empty()){ int size = q.size(); if(curr_dist++ == k) break; for(int i=0;ileft && !visted[curr->left]) { q.push(curr->left); visted[curr->left]=true; } if(curr->right && !visted[curr->right]) { q.push(curr->right); visted[curr->right]=true; } if(Keep_parent[curr] && !visted[Keep_parent[curr]]) { q.push(Keep_parent[curr]); visted[Keep_parent[curr]]=true; } } } vector ans; while(!q.empty()){ Node* temp = q.front(); q.pop(); ans.push_back(temp->data); } sort(ans.begin(),ans.end()); return ans; }
@pratikdas1780
@pratikdas1780 Год назад
this is outright amazing. wow! i'm amazed
@pratikdas1780
@pratikdas1780 Год назад
bro in the past, it's a simple bfs graph traversal technique after you link all the parent nodes. still, it's amazing. just not as hard.
@harshjhunjhunuwala
@harshjhunjhunuwala 2 года назад
Actually there's no need of "target" parameter in markParent function as it isn't used anywhere!
@1234abcd-qt6uz
@1234abcd-qt6uz 7 месяцев назад
for getting nodes at distance k visited map and array is not required only previous node is enough so that it doesn't call back (visited not required because this is not cyclic graph) for getting nodes at distance k CODE void dfsNodesAtDistanceK(TreeNode *node, TreeNode *pre, int k, unordered_map &parentMap, vector &ans) { if (k==0) { ans.push_back(node->val); return; } if (node->left && node->left!=pre) { dfsNodesAtDistanceK(node->left, node, k-1, parentMap, ans); } if (node->right && node->right!=pre) { dfsNodesAtDistanceK(node->right, node, k-1, parentMap, ans); } TreeNode *parent = parentMap[node]; if (parent!=NULL && parent!=pre) { dfsNodesAtDistanceK(parent, node, k-1, parentMap, ans); } return; } FULL CODE class Solution { private: void markParents(TreeNode *root, unordered_map &parentMap) { queue nodeQueue; nodeQueue.push(root); while (!nodeQueue.empty()) { TreeNode *node = nodeQueue.front(); nodeQueue.pop(); if (node->left) { parentMap[node->left] = node; nodeQueue.push(node->left); } if (node->right) { parentMap[node->right] = node; nodeQueue.push(node->right); } } return; } void dfsNodesAtDistanceK(TreeNode *node, TreeNode *pre, int k, unordered_map &parentMap, vector &ans) { if (k==0) { ans.push_back(node->val); return; } if (node->left && node->left!=pre) { dfsNodesAtDistanceK(node->left, node, k-1, parentMap, ans); } if (node->right && node->right!=pre) { dfsNodesAtDistanceK(node->right, node, k-1, parentMap, ans); } TreeNode *parent = parentMap[node]; if (parent!=NULL && parent!=pre) { dfsNodesAtDistanceK(parent, node, k-1, parentMap, ans); } return; } public: vector distanceK(TreeNode* root, TreeNode* target, int k) { unordered_map parentMap; markParents(root, parentMap); vector ans; dfsNodesAtDistanceK(target, NULL, k, parentMap, ans); return ans; } }; 863. All Nodes Distance K in Binary Tree
@sharmanihal99
@sharmanihal99 15 дней назад
Python Code to Find all Nodes a K Distance in Binary Tree: #Thanks for the Great Explanation class Solution: def distanceK(self, root: TreeNode, target: TreeNode, k: int) -> List[int]: # Function to perform breadth-first search to find parent nodes def bfs_to_find_parents(root): parent_map = {} # Maps a node's value to its parent node if not root: return parent_map queue = deque() queue.append(root) while queue: node = queue.popleft() if node.left: queue.append(node.left) parent_map[node.left.val] = node # Store parent for left child if node.right: queue.append(node.right) parent_map[node.right.val] = node # Store parent for right child return parent_map # Function to find nodes at distance k from the target node def find_nodes_with_distance_k(target, parent_map, k): queue = deque() queue.append(target) visited = set() visited.add(target.val) distance = 0 while distance != k: size = len(queue) while size: node = queue.popleft() # Check if parent exists and it hasn't been visited before if parent_map[node.val] and parent_map[node.val].val not in visited: queue.append(parent_map[node.val]) # Add parent to queue visited.add(parent_map[node.val].val) # Mark parent as visited # Add left child to queue if it exists and hasn't been visited if node.left and node.left.val not in visited: queue.append(node.left)# Add left child to queue visited.add(node.left.val)# Mark left child as visited # Add right child to queue if it exists and hasn't been visited if node.right and node.right.val not in visited: queue.append(node.right)# Add right child to queue visited.add(node.right.val)# Mark right child as visited size -= 1 distance += 1 return queue # Build parent map parent_map = bfs_to_find_parents(root) parent_map[root.val] = None # Set root's parent as None # Find nodes at distance k from target nodes_at_distance_k = find_nodes_with_distance_k(target, parent_map, k) # Extract values of nodes at distance k result = [node.val for node in nodes_at_distance_k] return result
@harshitjaiswal9439
@harshitjaiswal9439 4 месяца назад
understood.
@sanchitdeepsingh9663
@sanchitdeepsingh9663 6 месяцев назад
thanks sir
@subhankarpal2260
@subhankarpal2260 9 месяцев назад
Understood... thanks a lot.
@chandrachurmukherjeejucse5816
I solved it myself by another approach. Please let me know If It is a good approach or not. 1. Storing the path from root the the node in a deque using a dfs. 2. keep a count for how many elements are popped from deque 2. pop items from the front of deque and find the nodes at a dist (n - no of items popped). 3. Now to make sure that the latter popped node doesnot searches in the direction of the node popped previously we use a unordered set of popped out elements and after finding nodes at a dist for a node we put the node in the unordered set. Code: class Solution { private: bool dfs(TreeNode* root, TreeNode* target, deque &dq) { if(root == NULL) return false; if(root == target) { dq.push_back(target); return true; } bool isFound = false; isFound = dfs(root -> left, target, dq); isFound = isFound || dfs(root -> right, target, dq); if(isFound) { dq.push_back(root); return true; } return false; } void getAllNodes(TreeNode* curr, unordered_set &s, int dist, vector &res) { if(curr == NULL) return; if(s.find(curr) != s.end()) return; if(dist == 0) { res.push_back(curr -> val); return; } getAllNodes(curr -> left, s, dist - 1, res); getAllNodes(curr -> right, s, dist - 1, res); } public: vector distanceK(TreeNode* root, TreeNode* target, int k) { deque dq; unordered_set s; dfs(root, target, dq); vector res; int dist = k; while(!dq.empty()) { TreeNode* curr = dq.front(); dq.pop_front(); getAllNodes(curr, s, dist--, res); s.insert(curr); if(dist < 0) break; } return res; } };
@radharamamohanakunnattur3035
Understood!! awesome take
@infinityzero2321
@infinityzero2321 10 месяцев назад
I am thinking of anotger approach which is treating this like a directed graph. So instead of marking that whuch is the nodes parent we can just make an adj list and mark them like an undirected graph. Then we can directly do the bfs
@sukhpreetsingh5200
@sukhpreetsingh5200 Год назад
Amazing explanation😇
@chiragbansod8252
@chiragbansod8252 3 месяца назад
understood
@suryakiran2970
@suryakiran2970 Год назад
Great Explanation
@AKASHKUMAR-li7li
@AKASHKUMAR-li7li 4 дня назад
This can be easily solved using 1) root to node path 2) print all nodes k level down
@4747surya
@4747surya 8 месяцев назад
Basically convert tree into a undirected graph start from target and do k iteration of BFS ?
@Yash-uk8ib
@Yash-uk8ib 2 года назад
I initiallly thought of actually converting this tree to an undirected graph and just finding K distant nodes but your observation is just best!! Can u tell me why u took visited array??
@takeUforward
@takeUforward 2 года назад
So that I dont go back to them..
@Yash-uk8ib
@Yash-uk8ib 2 года назад
@@takeUforward sir u can visit back only parent nodes right? And that can be maintained using a variable?
@deepaktiwari7059
@deepaktiwari7059 2 года назад
@@Yash-uk8ib We can also revisit the target node from parent node(for eg 3 to 5)
@adityaagarwal2324
@adityaagarwal2324 2 года назад
Best explanation 🔥🔥
@satyamsrivastava9034
@satyamsrivastava9034 2 года назад
I encountered this problem in one of the interview I told him the approach which you have explained then he told me not to use the map to store the parents .. and then I shattered as I don't have that approach in mind. :(
@mukulsaluja6109
@mukulsaluja6109 2 года назад
U can store root to target node path
@saikrishnalanka133
@saikrishnalanka133 2 года назад
In the first step you can find the nodes which are at k distance below given node using recursive traversal. Then back track to each ancestor and store distance of ancestor in variable ( say d). Back track until k-d!=0. and at each ancestor call recursive again to find node at distance k-d.
@chirayubaliyan5181
@chirayubaliyan5181 Год назад
what about pair, you can use that also!Maybe!
@rijumondal6876
@rijumondal6876 6 месяцев назад
Do I need to go with a brute-better-optimal solution for this approach in the interview if asked??
@AlokKumar-ld9qr
@AlokKumar-ld9qr 2 года назад
amazing explanation. 😃😃😃
@SUMITKAUSHIK1000
@SUMITKAUSHIK1000 Год назад
/** * Definition for a binary tree node. * public class TreeNode { * int val; * TreeNode left; * TreeNode right; * TreeNode(int x) { val = x; } * } */ class Solution { public List distanceK(TreeNode root, TreeNode target, int k) { Map map = new HashMap(); Set visited = new HashSet(); List list = new ArrayList(); updateParent(null, root, map); traverse(k, target, map, list, visited); return list; } public void updateParent(TreeNode parent, TreeNode current, Map childToParent){ if(current == null) return; childToParent.put(current, parent); updateParent(current, current.left, childToParent); updateParent(current, current.right, childToParent); } public void traverse(int distance, TreeNode node, Map childToParent, List list, Set visited){ if(node == null) return; if(visited.contains(node)) return; visited.add(node); if(distance == 0){ list.add(node.val); return; } traverse(distance-1, node.left, childToParent, list, visited); traverse(distance-1, node.right, childToParent, list, visited); traverse(distance-1, childToParent.get(node), childToParent, list, visited); } }
@utkarshsharma6650
@utkarshsharma6650 2 года назад
understooood.thanks :)
@gigglezone3432
@gigglezone3432 Год назад
I solved it by converting tree to graph, and take adjacency list and bfs to traverse to all nodes at a distance of k? Is it a good approach for interviews?
@manojg4451
@manojg4451 Год назад
Love the concept of converting tree to graph, Please do a playlist for bits and sorting
@bhaveshkumar6842
@bhaveshkumar6842 2 года назад
Thank you bro!!!!
@rohan8758
@rohan8758 2 месяца назад
Key Notes: - Mark each node to its parent to traverse upwards - We will do a BFS traversal starting from the target node - As long as we have not seen our node previously, Traverse up, left, right until reached Kth distance - When reached Kth distance, break out of BFS loop and remaining node's values in our queue is our result.
@vaibhav56
@vaibhav56 Год назад
Solution without using any extra space for storing the parent: class Solution { public: vector ans; void down(TreeNode* target,int k){ if(!target)return; if(k==0){ ans.push_back(target->val); return; } down(target->left,k-1); down(target->right,k-1); } bool up(TreeNode* root,TreeNode* target,int &k){ if(!root)return false; if(root==target)return true; if(up(root->left,target,k)){ k--; if(k==0)ans.push_back(root->val); down(root->right,k-1); return true; } if(up(root->right,target,k)){ k--; if(k==0)ans.push_back(root->val); down(root->left,k-1); return true; } return false; } vector distanceK(TreeNode* root, TreeNode* target, int k) { down(target,k); up(root,target,k); return ans; } };
@lavanyaprakashjampana933
@lavanyaprakashjampana933 Год назад
we love your content and we love you.....🖤
@nihalnandannayak8869
@nihalnandannayak8869 Год назад
What is the need of passing target node as argument of the function markparen()
@jothsna
@jothsna 11 месяцев назад
Nice explanation☺
@pranavsharma7479
@pranavsharma7479 Год назад
simple bfs traversal on the graph
@santanu29
@santanu29 2 года назад
Great explanation
@rishabsharma5307
@rishabsharma5307 2 года назад
please make videos on finding time complexity of finding complex questions
@takeUforward
@takeUforward 2 года назад
Comes with practice, don't think on that too much :)
@parthsalat
@parthsalat Год назад
Please do a smooth transition from black iPad to white Code screen...I've become blind because of the quick transition 😥
@ajitheshgupta3017
@ajitheshgupta3017 2 года назад
If it was print all from lead node. What changes has to be done?
@prashantpandey2848
@prashantpandey2848 Год назад
we can avoid second loop using one more queue
@vedantsharma5876
@vedantsharma5876 2 года назад
Should this(or a similar) question be asked in an interview? Because it took me almost 1 hour to just code!
@amanbhadani8840
@amanbhadani8840 2 года назад
Yes definitely,You have to work on your speed.
@pritishpattnaik4674
@pritishpattnaik4674 Год назад
Just Excellent
@alesblaze4745
@alesblaze4745 Год назад
thanks mate!
@YashKakrecha
@YashKakrecha 10 месяцев назад
Wow nice explanation
@g.upenderreddy
@g.upenderreddy 11 месяцев назад
we could use Set to keep track of visited nodes. public List distanceK(TreeNode root, TreeNode target, int k) { Map parentMap = markParentNodes(root); Set visited = new HashSet(); Deque queue = new LinkedList(); visited.add(target); queue.offer(target); int currentLevel = 0 , size = 0; while (!queue.isEmpty()) { if (currentLevel == k) break; currentLevel++; size = queue.size(); for (int i = 0; i< size; i++) { TreeNode node = queue.poll(); if (node.left != null && !visited.contains(node.left)) { queue.offer(node.left); visited.add(node.left); } if (node.right != null && !visited.contains(node.right)) { queue.offer(node.right); visited.add(node.right); } TreeNode parent = parentMap.get(node); if (parent != null && !visited.contains(parent)) { queue.offer(parent); visited.add(parent); } } } return queue.stream().map(node -> node.val).toList(); } public Map markParentNodes(TreeNode root) { Map parentMap = new HashMap(); // store Deque queue = new LinkedList(); queue.offer(root); while (!queue.isEmpty()) { TreeNode node = queue.poll(); if (node.left != null) { parentMap.put(node.left, node); queue.offer(node.left); } if (node.right != null) { parentMap.put(node.right, node); queue.offer(node.right); } } return parentMap; }
@pritamsaha7129
@pritamsaha7129 Год назад
What happens when we get two nodes of same value?? Will unordered map work at that time??
@DevanshuAugusty
@DevanshuAugusty Год назад
why are you passing the target node int mark parent function?
Далее
L28. Maximum Width of Binary Tree | C++ | Java
22:41
Просмотров 219 тыс.
8 patterns to solve 80% Leetcode problems
7:30
Просмотров 194 тыс.
L24. Right/Left View of Binary Tree | C++ | Java
13:28
Просмотров 184 тыс.
I gave 127 interviews. Top 5 Algorithms they asked me.
8:36
BS-17. Aggressive Cows | Binary Search Hard
26:44
Просмотров 115 тыс.